!  Thu Oct 22 15:49:17 CEST 2015
!  Written by Pedro Ojeda
program main
      use MPI 
      integer :: ierr,rank,size
      integer :: status(MPI_STATUS_SIZE)
      integer,parameter :: num_elem=10000
      integer :: a(num_elem),b(num_elem)

      call MPI_INIT( ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE( MPI_COMM_WORLD, size, ierr)

!Note: this code works well, there is no dead-lock,
!if number of elements is small (num_elem)
!because the buffer can deal with such an array
      if(rank == 0) then
              do i=1,num_elem
                  a(i)=i
                  b(i)=2*i
              enddo
              write(6,10) 'rank 0 a',(a(i),i=1,10)
              write(6,10) 'rank 0 b',(b(i),i=1,10)
              call MPI_SEND(a,num_elem,MPI_INT,1,1,MPI_COMM_WORLD,ierr)
              call MPI_SEND(b,num_elem,MPI_INT,1,2,MPI_COMM_WORLD,ierr)
      elseif(rank ==1) then
              call MPI_RECV(b,num_elem,MPI_INT,0,2,MPI_COMM_WORLD,status,ierr)
              write(6,10) 'rank 1 b',(b(i),i=1,10)
              call MPI_RECV(a,num_elem,MPI_INT,0,1,MPI_COMM_WORLD,status,ierr)
              write(6,10) 'rank 1 a',(a(i),i=1,10)
      else 
          print *, 'no other task'

      endif

10    format(A12,10I7)
      call MPI_FINALIZE( ierr )

end
