      program scatter
      include 'mpif.h'

      integer SIZE
      parameter(SIZE=4)
      integer numtasks, rank, sendcount, recvcount, source, ierr
      integer sendbuf(SIZE,SIZE), recvbuf(SIZE)

!     Fortran stores this array in column major order, so the 
!     scatter will actually scatter columns, not rows.
      data sendbuf /1, 2, 3, 4, &
                   5, 6, 7, 8, &
                   9, 10, 11, 12, & 
                   13, 14, 15, 16 /

      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, numtasks, ierr)

      do i=1,size
         write(6,*) rank, (sendbuf(i,j),j=1,size)
      enddo
      if (numtasks .eq. SIZE) then
         source = 1
         sendcount = SIZE
         recvcount = SIZE
         call MPI_SCATTER(sendbuf, sendcount, MPI_INTEGER, recvbuf, &
             recvcount, MPI_INTEGER, source, MPI_COMM_WORLD, ierr)
         print *, 'rank= ',rank,' Results: ',recvbuf 
      else
         print *, 'Must specify',SIZE,' processors.  Terminating.' 
      endif

      call MPI_FINALIZE(ierr)

      end
