program monte_carlo_mpi
      !USE MPI
      implicit none
      include "mpif.h"

      integer*8 npts,mynpts
      parameter (npts = 1e9)


      integer ierr, myid, nprocs

      integer*8 i

      real*8 f,sum,mysum
      real*8 xmin,xmax,x

      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, myid, ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)

      if (myid .eq. 0) then
         mynpts = npts - (nprocs-1)*(npts/nprocs)
      else
         mynpts = npts/nprocs
      endif

      mysum = 0.0d0
      xmin = 0.0d0
      xmax = 1.0d0

      x = (xmax-xmin)*rand(myid+1) + xmin
      do i=1,mynpts
         x = (xmax-xmin)*rand(0) + xmin
         mysum = mysum + 4.0d0/(1.0d0 + x**2)
      enddo

      call MPI_REDUCE(mysum,sum,1,MPI_DOUBLE_PRECISION,MPI_SUM,0,MPI_COMM_WORLD,ierr)
      
      if (myid .eq. 0) then
         f = sum/npts
         write(*,*)'PI calculated with ',npts,' points = ',f
      endif

      call MPI_FINALIZE(ierr)

      stop
      end 
